package primi;
import test.*;

public class PrimiTest extends AbstractTest {
	
	public static void main(String[] args) {
		System.out.println("start");
		PrimiTest pt = new PrimiTest("./primi.xml", "./primi.txt");
		pt.doAllTests();
		pt.printReport();
		System.out.println("end");
	}

	AbstractPrimi P;

	String PGM, N, RES;

	public PrimiTest(String input, String output) {
		super(input, output);
	}

	protected void go() {
		PGM = H.get("PGM");
		N = H.get("N");
		long n = Long.parseLong(N);
		int resOK = Integer.parseInt(H.get("RES"));

		if (PGM.equals("Primi1"))
			P = new Primi1(n);
		else if (PGM.equals("Primi2"))
			P = new Primi2(n);
		else if (PGM.equals("Primi3"))
			P = new Primi3(n);
		else if (PGM.equals("Crivello"))
			P = new Crivello(n);
		else if (PGM.equals("CrivelloBitSet"))
			P = new CrivelloBitSet(n);
		else if (PGM.equals("CrivelloPrimeSet"))
			P = new CrivelloPrimeSet(n);
		else if (PGM.equals("CrivelloPrimeSet2"))
			P = new CrivelloPrimeSet2(n);
		else if (PGM.equals("CrivelloPrimeSet5"))
			P = new CrivelloPrimeSet5(n);
		else
			throw new IllegalArgumentException(" Unknown PGM");
		
		System.out.println(" testing "+PGM+" size "+n);	
		int resC = P.go();
		if (resOK == resC)
			RES = "OK";
		else
			RES = " ERROR: computed value " + resC+ " exact value " + resOK;
	}

	protected String getRes() {
		return RES;
	}

	protected void pre() {}

	protected void post() {
		reportT.put(N, PGM, time);
		reportM.put(N, PGM, mem);
	}
}